#pragma once

#include "gui.h"
#include "framebuffer.h"
#include "ppc.h"
#include "tmesh.h"

class Scene {
public:
  
  GUI *gui;
  FrameBuffer *fb, *hwfb;
  PPC *ppc, ppc0, ppc1;
  V3 *cube;
  TMesh *tmeshes, *depthImage;
  int tmeshesN;
  FrameBuffer *shadowMap;
  PPC *lightCamera;
  V3 lightPoint;
  Scene();
  void DBG();
  void NewButton();
  void Render();
  void View0();
  void View1();
  void Int01();
  void Int10();
  void UpdateShadowMap();
  void SaveView();
  void LoadView();

  void RenderHW();
  bool copyHW;

};

extern Scene *scene;
